require "a-star"

local player = {
  pos_x = 2,
  pos_y = 2,
  path = nil,
  path_index = 1,
  move_time = 1
}

local map

function LoadMap(filename)  
  local file = io.open(filename)
  local i = 1
  map = {}
  for line in file:lines() do
    map[i] = {}
    for j=1, #line, 1 do
      map[i][j] = line:sub(j,j)
    end
    i = i + 1
  end
  file:close()
end

function love.load()
  LoadMap("Mapa.txt")    
end

function love.mousereleased(mx, my, bt)
  if bt == 1 then
    player.path = astar_path({x = player.pos_y, y = player.pos_x}, {x = math.floor(my/32), y = math.floor(mx/32)}, map) 
    player.path_index = 1
    player.move_time = 0
  end
end

function love.update(dt) 
  if player.path ~= nil then
    player.pos_x = player.path[player.path_index].y;
    player.pos_y = player.path[player.path_index].x;
    
    player.move_time = player.move_time + dt
    if player.move_time > 0.1 then
      if player.path_index < table.getn(player.path) then
        player.path_index = player.path_index + 1
      end
      player.move_time = 0      
    end    
  end
end

function love.draw()
  for i=1, 17, 1 do
    for j=1, 23, 1 do
      if (map[i][j] == "0") then
        love.graphics.setColor(0, 0, 0)
      elseif (map[i][j] == "1") then
        love.graphics.setColor(1, 1, 1)
      end
      love.graphics.rectangle("fill", (j * 32), (i * 32), 32, 32)
    end
  end
  love.graphics.setColor(1, 0, 0)
  love.graphics.circle("fill", (player.pos_x * 32) + 16, (player.pos_y * 32) + 16, 16, 32)
end
